/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest{}

// DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest 
type DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest struct {
	Key string `json:"key"`
}

// NewDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest instantiates a new DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest(key string) *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest {
	this := DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest{}
	this.Key = key
	return &this
}

// NewDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequestWithDefaults instantiates a new DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequestWithDefaults() *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest {
	this := DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest{}
	return &this
}

// GetKey returns the Key field value
func (o *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) GetKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Key
}

// GetKeyOk returns a tuple with the Key field value
// and a boolean to check if the value has been set.
func (o *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) GetKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Key, true
}

// SetKey sets field value
func (o *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) SetKey(v string) {
	o.Key = v
}

func (o DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["key"] = o.Key
	return toSerialize, nil
}

type NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest struct {
	value *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest
	isSet bool
}

func (v NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) Get() *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest {
	return v.value
}

func (v *NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) Set(val *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest(val *DeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) *NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest {
	return &NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest{value: val, isSet: true}
}

func (v NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDeleteOrganizationsOrganizationIdContactsContactIdSegmentRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


